<?php

declare(strict_types=1);

namespace Internetgalerie\IgCrmTemplate\Domain\Repository;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings;

/**
 * The repository for TemplatePageLayouts
 */
class TemplatePageLayoutRepository extends \TYPO3\CMS\Extbase\Persistence\Repository
{



    protected $defaultOrderings = [
        'tenantId' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING, 
        'templateType' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
    ];

    public function initializeObject()
    {
        $querySettings = GeneralUtility::makeInstance(Typo3QuerySettings::class);
        $querySettings->setRespectStoragePage(false);
        $this->setDefaultQuerySettings($querySettings);
     }

    public function findOneByTenantUidAndTemplateTypeName(?int $tenantUid, string $templateType)
    {
        $query = $this->createQuery();
        $constraints = [
            $query->logicalOr(
                $query->equals('tenantId', null),
                $query->equals('tenantId', 0),
                $query->equals('tenantId', (int)$tenantUid),
            ),
            $query->logicalOr(
                $query->equals('templateType', null),
                $query->equals('templateType.name', $templateType),
            ),
        ];
        $query->matching(
            $query->logicalAnd(...$constraints)
        );
        return $query->execute()->getFirst();
    }


}
