<?php
namespace Internetgalerie\IgCrmTemplate\ViewHelpers;

use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface;

class ContentViewHelper extends AbstractViewHelper
{

    protected $escapeOutput = false;
    
    
    /**
     * Initialize the arguments.
     * @return void
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        //$this->registerArgument('content', 'array', 'value to use', true);
        //$this->registerArgument('name', 'string', 'value to use', true);
        $this->registerArgument('value', 'array|string', 'value to use', false);
        $this->registerArgument('formatHtml', 'bool', 'use f:format.html to fromat value', false, true);
        $this->registerArgument('parse', 'bool', 'use f:inline to parse value', false, false);
    }
    /**
     * Content Renderer
     * @return string
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    )
    {
        /*$name = $arguments['name'];
        $content = $arguments['content'];
        $html = $content[$name] ?? '';
        */
        $parse = $arguments['parse'];
        $formatHtml = $arguments['formatHtml'];
        if (is_array($arguments['value'])) {
            $html = $arguments['value']['value'];
            $parse = $arguments['value']['parse'] ?? $arguments['parse'];
            $formatHtml = $arguments['value']['formatHtml'] ?? $arguments['formatHtml'];
        } else {
            $html = (string)$arguments['value'];
        }
        if ($html ===null | $html == '') {
            return '';
        }
        if ($parse) {
            $html = $renderingContext->getTemplateParser()->parse($html)->render($renderingContext);
        }
        if ($formatHtml) {
            $html = htmlspecialchars($html);
        }
        return $html;

    }
}