<?php

$versionInformation = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Information\Typo3Version::class);
if ($versionInformation->getMajorVersion() > 11) {
    $logosConfig = [
        'type' => 'file',
        'foreign_match_fields' => [
            'tablenames' => 'tx_igcrmtemplate_domain_model_templateletter',
        ],
        'maxitems' => 9999,
        'allowed' => 'common-image-types',
    ];
} else {
    $logosConfig = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
        'image',
        [
            'appearance' => [
                'createNewRelationLinkTitle' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:images.addFileReference'
            ],
            'foreign_match_fields' => [
                'tablenames' => 'tx_igcrmtemplate_domain_model_templateletter',
                'table_local' => 'sys_file',
            ],
            'foreign_types' => [
                '0' => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ],
                \TYPO3\CMS\Core\Resource\File::FILETYPE_TEXT => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ],
                \TYPO3\CMS\Core\Resource\File::FILETYPE_IMAGE => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ],
                \TYPO3\CMS\Core\Resource\File::FILETYPE_AUDIO => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ],
                \TYPO3\CMS\Core\Resource\File::FILETYPE_VIDEO => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ],
                \TYPO3\CMS\Core\Resource\File::FILETYPE_APPLICATION => [
                    'showitem' => '
                            --palette--;LLL:EXT:lang/locallang_tca.xlf:sys_file_reference.imageoverlayPalette;imageoverlayPalette,
                            --palette--;;filePalette'
                ]
            ],
            'maxitems' => 9999
        ],
        $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']
    );
}

return [
    'ctrl' => [
        'title' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter',
        'label' => 'name',
        'tstamp' => 'tstamp',
        'crdate' => 'crdate',
        'cruser_id' => 'cruser_id',
        'delete' => 'deleted',
        'enablecolumns' => [
            'disabled' => 'hidden',
            'starttime' => 'starttime',
            'endtime' => 'endtime',
        ],
        'searchFields' => 'name,title, template, partial_before, partial_footer, partial_after, partial_header, page_template',
        'iconfile' => 'EXT:ig_crm_template/Resources/Public/Icons/tx_igcrmtemplate_domain_model_templateletter.gif'
    ],
    'types' => [
        '1' => ['showitem' => 'sys_language_uid, l10n_parent, l10n_diffsource, hidden, active, favorite, name, tenant_id, template_type, template_object_type, main_tags, sub_tags, object_type, crm_language, template_object_items_per_page, title, title_layout, logos, partial_header, partial_footer, page_template, show_number, show_letter_date, show_sender, show_pp, show_mwst, text_before, partial_before, template, partial_after, text_after, page_css_file, page_class, filename'],
    ],
    'columns' => [
        'hidden' => [
            'exclude' => true,
            'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.hidden',
            'config' => [
                'type' => 'check',
                'items' => [
                    '1' => [
                        '0' => 'LLL:EXT:lang/Resources/Private/Language/locallang_core.xlf:labels.enabled'
                    ]
                ],
            ],
        ],
        'starttime' => [
            'exclude' => true,
            'behaviour' => [
                'allowLanguageSynchronization' => true
            ],
            'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.starttime',
            'config' => [
                'type' => 'input',
                'renderType' => 'inputDateTime',
                'size' => 13,
                'eval' => 'datetime',
                'default' => 0,
            ],
        ],
        'endtime' => [
            'exclude' => true,
            'behaviour' => [
                'allowLanguageSynchronization' => true
            ],
            'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.endtime',
            'config' => [
                'type' => 'input',
                'renderType' => 'inputDateTime',
                'size' => 13,
                'eval' => 'datetime',
                'default' => 0,
                'range' => [
                    'upper' => mktime(0, 0, 0, 1, 1, 2038)
                ],
            ],
        ],
        'active' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.active',
            'config' => [
                'type' => 'check',
                'items' => [
                    [
                        'LLL:EXT:lang/Resources/Private/Language/locallang_core.xlf:labels.enabled'
                    ]
                ],
                'default' => 1,
            ],
        ],
        'favorite' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.favorite',
            'config' => [
                'type' => 'check',
                'items' => [
                    [
                        'LLL:EXT:lang/Resources/Private/Language/locallang_core.xlf:labels.enabled'
                    ]
                ],
                'default' => 1,
            ],
        ],
        'crm_language' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.crm_language',
            'config' => [
               'type' => 'input',
                'size' => 30,
                'eval' => 'trim,int,null'
            ],
        ],
         'name' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.name',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
         'template_object_type' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.template_object_type',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'items' => [
                    [  'LLL:EXT:ig_fibu/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoice.type.invoice', 'Invoice' ],
                    [  'LLL:EXT:ig_fibu/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoice.type.invoiceAnnual', 'InvoiceAnnual'],
                ],
                'default' => 'Invoice'
            ],
        ],
        'template_object_items_per_page' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.template_object_items_per_page',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'int,null'
            ],
        ],
        'template_type' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.template_type',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'foreign_table' => 'tx_igcrmtemplate_domain_model_templatetype',
                'default' => 0,
                'minitems' => 0,
                'maxitems' => 1,
            ],
        ],
        'invoice_type' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.invoice_type',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
         'object_type' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.object_type',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'items' => [
                    ['Alle', null],
                    ['Person', 'Person'],
                    ['Organisation', 'Organisation'],
                ],
                'eval' => 'null',
            ],
        ],
        'main_tags' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.main_tags',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'sub_tags' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.sub_tags',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
         'title' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.title',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
         'title_layout' => [
            'exclude' => true,
            'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.type',
            'config' => [
                'type' => 'select',
                'renderType' => 'selectSingle',
                'items' => [
                    [
                        'label' => 'LLL:EXT:core/Resources/Private/Language/locallang_general.xlf:LGL.default_value',
                        'value' => 0,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.1',
                        'value' => 1,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.2',
                        'value' => 2,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.3',
                        'value' => 3,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.4',
                        'value' => 4,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.5',
                        'value' => 5,
                    ],
                    [
                        'label' => 'LLL:EXT:frontend/Resources/Private/Language/locallang_ttc.xlf:header_layout.I.6',
                        'value' => 100,
                    ],
                ],
                'default' => 0,
            ],
         ],
        'tenant_id' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.tenant_id',
            'config' => [
               'type' => 'input',
                'size' => 30,
                'eval' => 'trim,int,null'
            ],
        ],

        'text_before' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.text_before',
            'config' => [
                'type' => 'text',
                'enableRichtext' => true,
                'richtextConfiguration' => 'default',
                'fieldControl' => [
                    'fullScreenRichtext' => [
                        'disabled' => false,
                    ],
                ],
                'cols' => 40,
                'rows' => 15,
                'eval' => 'trim'
            ],
        ],
        'partial_header' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.partial_header',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'partial_footer' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.partial_footer',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'show_number' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.show_number',
            'config' => [
                'type' => 'check',
                'default' => 0
            ]
        ],
        'show_letter_date' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.show_letter_date',
            'config' => [
                'type' => 'check',
                'default' => 1
            ]
        ],
        'show_sender' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.show_sender',
            'config' => [
                'type' => 'check',
                'default' => 0
            ]
        ],
        'show_pp' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.show_pp',
            'config' => [
                'type' => 'check',
                'default' => 0
            ]
        ],
        'show_mwst' => [
            'exclude' => 1,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.show_mwst',
            'config' => [
                'type' => 'check',
                'default' => 0
            ]
        ],
        'partial_before' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.partial_before',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'template' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.template',
            'config' => [
                'type' => 'text',
                'cols' => 40,
                'rows' => 15,
                'eval' => 'trim'
            ],
        ],
        'page_template' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.page_template',
            'config' => [
                'type' => 'text',
                'cols' => 40,
                'rows' => 15,
                'eval' => 'trim'
            ],
        ],

        'partial_after' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.partial_after',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        
        'text_after' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.text_after',
            'config' => [
                'type' => 'text',
                'enableRichtext' => true,
                'richtextConfiguration' => 'default',
                'fieldControl' => [
                    'fullScreenRichtext' => [
                        'disabled' => false,
                    ],
                ],
                'cols' => 40,
                'rows' => 15,
                'eval' => 'trim'
            ],
        ],

        'logos' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.logos',
            'config' => $logosConfig,
        ],
        'page_css_file' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate_domain_model_templateletter.page_css_file',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'page_class' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate.page_class',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],
        'filename' => [
            'exclude' => true,
            'label' => 'LLL:EXT:ig_crm_template/Resources/Private/Language/locallang_db.xlf:tx_igcrmtemplate.filename',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'trim'
            ],
        ],

        
    ],
];
